import unittest
from day_12 import day_12


class Day12(unittest.TestCase):
  def test_task_1(self):
    lines = [
      "???.### 1,1,3",
      ".??..??...?##. 1,1,3",
      "?#?#?#?#?#?#?#? 1,3,1,6",
      "????.#...#... 4,1,1",
      "????.######..#####. 1,6,5",
      "?###???????? 3,2,1",
    ]
    self.assertEqual(day_12.task_1(lines), 21)

  def test_task_1_rec(self):
    lines = [
      "???.### 1,1,3",
      ".??..??...?##. 1,1,3",
      "?#?#?#?#?#?#?#? 1,3,1,6",
      "????.#...#... 4,1,1",
      "????.######..#####. 1,6,5",
      "?###???????? 3,2,1",
    ]
    self.assertEqual(day_12.task_2(lines, expand=1), 21)
  
  def test_task_2(self):
    lines = [
      "???.### 1,1,3",
      ".??..??...?##. 1,1,3",
      "?#?#?#?#?#?#?#? 1,3,1,6",
      "????.#...#... 4,1,1",
      "????.######..#####. 1,6,5",
      "?###???????? 3,2,1",
    ]
    self.assertEqual(day_12.task_2(lines), 525152)
  

if __name__ == '__main__':
    unittest.main()